------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

with Qt_Ada.Internals.Objects.Plugin_Loader_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Plugin_Loader_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Plugin_Loaders is

   procedure errorString_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, errorString_0_wrapper,
                     "__Qt4Ada_QPluginLoader_errorString_0_wrapper");

   procedure fileName_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, fileName_0_wrapper,
                     "__Qt4Ada_QPluginLoader_fileName_0_wrapper");

   function instance_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, instance_0_wrapper,
                     "__Qt4Ada_QPluginLoader_instance_0_wrapper");

   function isLoaded_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isLoaded_0_wrapper,
                     "__Qt4Ada_QPluginLoader_isLoaded_0_wrapper");

   function load_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, load_0_wrapper,
                     "__Qt4Ada_QPluginLoader_load_0_wrapper");

   procedure setFileName_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     File_Name : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setFileName_0_wrapper,
                     "__Qt4Ada_QPluginLoader_setFileName_0_wrapper");

   function unload_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, unload_0_wrapper,
                     "__Qt4Ada_QPluginLoader_unload_0_wrapper");

   pragma Style_Checks ("N");

   ------------------
   -- Error_String --
   ------------------

   function Error_String
    (Self : not null access constant Q_Plugin_Loader'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      errorString_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Error_String;

   ---------------
   -- File_Name --
   ---------------

   function File_Name
    (Self : not null access constant Q_Plugin_Loader'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      fileName_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end File_Name;

   --------------
   -- Instance --
   --------------

   function Instance
    (Self : not null access Q_Plugin_Loader'Class)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (instance_0_wrapper
           (Self.QObject_View));
   end Instance;

   ---------------
   -- Is_Loaded --
   ---------------

   function Is_Loaded
    (Self : not null access constant Q_Plugin_Loader'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isLoaded_0_wrapper
           (Self.QObject_View));
   end Is_Loaded;

   ----------
   -- Load --
   ----------

   function Load
    (Self : not null access Q_Plugin_Loader'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (load_0_wrapper
           (Self.QObject_View));
   end Load;

   -------------------
   -- Set_File_Name --
   -------------------

   procedure Set_File_Name
    (Self : not null access Q_Plugin_Loader'Class;
     File_Name : Qt4.Strings.Q_String)
   is
   begin
      setFileName_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (File_Name));
   end Set_File_Name;

   ------------
   -- Unload --
   ------------

   function Unload
    (Self : not null access Q_Plugin_Loader'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (unload_0_wrapper
           (Self.QObject_View));
   end Unload;

end Qt4.Plugin_Loaders;
